Thread (16 messages) 16 messages, 3 authors, 2023-01-31

Re: [PATCH v2 3/4] selftests: net: udpgso_bench: Fix racing bug between the rx/tx programs

From: Willem de Bruijn <willemb@google.com>
Date: 2023-01-31 13:34:22
Also in: linux-kselftest, lkml

On Tue, Jan 31, 2023 at 8:06 AM Andrei Gherzan
[off-list ref] wrote:
"udpgro_bench.sh" invokes udpgso_bench_rx/udpgso_bench_tx programs
subsequently and while doing so, there is a chance that the rx one is not
ready to accept socket connections. This racing bug could fail the test
with at least one of the following:

./udpgso_bench_tx: connect: Connection refused
./udpgso_bench_tx: sendmsg: Connection refused
./udpgso_bench_tx: write: Connection refused

This change addresses this by making udpgro_bench.sh wait for the rx
program to be ready before firing off the tx one - with an exponential back
off algorithm from 1s to 10s.

Signed-off-by: Andrei Gherzan <redacted>
please CC: reviewers of previous revisions on new revisions

also for upcoming patches: please clearly mark net or net-next.
quoted hunk ↗ jump to hunk
---
 tools/testing/selftests/net/udpgso_bench.sh | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)
diff --git a/tools/testing/selftests/net/udpgso_bench.sh b/tools/testing/selftests/net/udpgso_bench.sh
index dc932fd65363..20b5db8fcbde 100755
--- a/tools/testing/selftests/net/udpgso_bench.sh
+++ b/tools/testing/selftests/net/udpgso_bench.sh
@@ -7,6 +7,7 @@ readonly GREEN='\033[0;92m'
 readonly YELLOW='\033[0;33m'
 readonly RED='\033[0;31m'
 readonly NC='\033[0m' # No Color
+readonly TESTPORT=8000 # Keep this in sync with udpgso_bench_rx/tx
then also pass explicit -p argument to the processes to keep all three
consistent
quoted hunk ↗ jump to hunk
 readonly KSFT_PASS=0
 readonly KSFT_FAIL=1
@@ -56,10 +57,27 @@ trap wake_children EXIT

 run_one() {
        local -r args=$@
+       local -r init_delay_s=1
+       local -r max_delay_s=10
+       local delay_s=0
+       local nr_socks=0

        ./udpgso_bench_rx &
        ./udpgso_bench_rx -t &

+       # Wait for the above test program to get ready to receive connections.
+       delay_s="${init_delay_s}"
+       while [ "$delay_s" -lt "$max_delay_s" ]; do
+               nr_socks="$(ss -lnHi | grep -c "\*:${TESTPORT}")"
+               [ "$nr_socks" -eq 2 ] && break
+               sleep "$delay_s"
+               delay="$((delay*2))"
I don't think we need exponential back-off for something this simple
+       done
+       if [ "$nr_socks" -ne 2 ]; then
+               echo "timed out while waiting for udpgso_bench_rx"
+               exit 1
+       fi
+
        ./udpgso_bench_tx ${args}
 }

--
2.34.1
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help